﻿' Copyright © exc-jdbi 2017
'
' © NumeralSystemConverter1000 2017
'
' NumeralSystemConverter1000 is Free and Opensource Software
'
' www.vb-paradise.de/index.php/User/23082-exc-jdbi/
'
' github.com/exc-jdbi

Option Strict On
Option Explicit On

'Random1000 dient der Hilfe, um einen Anfangswert (hier in Array) in der gewünschten Basis zu erhalten.
'Dazu wird gleich bei der Instanzierung der Zufallsgenerator angeworfen + eine Array mit zufälligen 
'Zahlen generiert, die in der Membervariable mRnd festgehalten wird.
'Die Startbasis ist immer 10 und 'targetBasis' ist die neue gwünschte Basis

'Es sind keine Endbasis 0 oder 1 erlaubt

Public Class Random1000
    Private rnd As Random
    Private mRnd As Integer()

    'Generiert einen neuen Anfangswert (Array) und übergibt es an die Membervariable mRng
    'Danach wird der Anfangswert (Array) zurückgegeben.
    Public ReadOnly Property NewRnd1000(ByVal targetBase As Integer) As Integer()
        Get
            mRnd = If(targetBase > 1, prnd1000(targetBase), Nothing)
            Return mRnd
        End Get
    End Property

    'Generiert einen zufälligen Anfangswert in der Basis 10
    <System.Diagnostics.DebuggerStepThrough()> _
    Private Function prnd1000() As Integer()
        Dim iMax As Integer = 16 - 1
        Dim iRnd() As Integer = New Integer(iMax) {}
        For i As Integer = 0 To iMax
            iRnd(i) = rnd.Next(10)
        Next
        Return iRnd
    End Function

    'Holt sich mit der oberen Funktion einen neuen Anfangswert in der Basis 10 
    'und rechnet es um in die gewünschte Basis (>1) mit Hilfe der Klasse NSC.
    <System.Diagnostics.DebuggerStepThrough()> _
    Private Function prnd1000(ByVal targetBase As Integer) As Integer()
        If targetBase > 1 Then
            Dim n As NSC
            Dim iAMax() As Integer = prnd1000()
            If targetBase = 10 Then
                Return iAMax
            Else : n = New NSC
                Return n.convert(iAMax, 10, targetBase)
            End If
        End If
        Return Nothing
    End Function

    'Konstruktor
    'Stellt sicher, dass bei der Instanzierung der Klasse NSC, der Zufallszahlen-
    'Generator EINMAL aktiviert wird, und der zufällige Anfangswert (in Array) an die Membervariable
    'mRnd übergeben wird.
    <System.Diagnostics.DebuggerStepThrough()> _
    Public Sub New()
        rnd = New Random
        mRnd = prnd1000(rnd.Next(10))
    End Sub
End Class
